Name:           ocaml-qcheck
Version:        0.10
Release:        2%{?dist}
Summary:        QuickCheck inspired property-based testing for OCaml

License:        BSD
URL:            https://github.com/c-cube/qcheck
Source0:        https://github.com/c-cube/qcheck/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  ocaml
BuildRequires:  ocaml-dune
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ounit-devel
BuildRequires:  opam-installer


%description
This module allows to check invariants (properties of some types) over
randomly generated instances of the type. It provides combinators for
generating instances and printing them.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%setup -q -n qcheck-%{version}


%build
# do not build alcotest support since it is not packaged yet
dune build @install -p qcheck,qcheck-core,qcheck-ounit --verbose


%install
mkdir -p %{buildroot}%{_libdir}/ocaml
dune install --destdir=%{buildroot} qcheck qcheck-core qcheck-ounit

# These files will be installed using doc and license directives.
rm -r %{buildroot}%{_prefix}/doc

# Makes *.cmxs executable such that they will be stripped.
find %{buildroot} -name '*.cmxs' -exec chmod 0755 {} \;

%check
dune runtest --no-buffer --profile release


%files
%doc README.adoc CHANGELOG.md
%license LICENSE
%{_libdir}/ocaml/*
%{_libdir}/ocaml/*/*
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/*/{,*/}*.a
%exclude %{_libdir}/ocaml/*/{,*/}*.cmxa
%exclude %{_libdir}/ocaml/*/{,*/}*.cmx
%endif
%exclude %{_libdir}/ocaml/*/{,*/}*.ml
%exclude %{_libdir}/ocaml/*/{,*/}*.mli


%files devel
%doc README.adoc CHANGELOG.md
%license LICENSE
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/*/{,*/}*.a
%{_libdir}/ocaml/*/{,*/}*.cmxa
%{_libdir}/ocaml/*/{,*/}*.cmx
%endif
%{_libdir}/ocaml/*/{,*/}*.ml
%{_libdir}/ocaml/*/{,*/}*.mli
%{_libdir}/ocaml/*/{,*/}*.cma
%{_libdir}/ocaml/*/{,*/}*.cmi
%{_libdir}/ocaml/*/{,*/}*.cmt
%{_libdir}/ocaml/*/{,*/}*.cmti
%{_libdir}/ocaml/*/dune-package
%{_libdir}/ocaml/*/META
%{_libdir}/ocaml/*/opam


%changelog
* Thu Aug 01 2019 Richard W.M. Jones <rjones@redhat.com> - 0.10-2
- OCaml 4.08.1 (rc2) rebuild.

* Sat Jul 27 2019 Andy Li <andy@onthewings.net> - 0.10-1
- New upstream release.
- Update build system and commands from jbuilder to dune.

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Jul 11 2018 Richard W.M. Jones <rjones@redhat.com> - 0.8-5
- OCaml 4.07.0 (final) rebuild.

* Wed Jun 20 2018 Richard W.M. Jones <rjones@redhat.com> - 0.8-4
- OCaml 4.07.0-rc1 rebuild.

* Mon May 14 2018 Andy Li <andy@onthewings.net> - 0.8-3
- Rebuilt against ounit.

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Feb 05 2018 Andy Li <andy@onthewings.net> - 0.8-1
- New upstream release. (RHBZ#1541681)
- Enable debug package.

* Sat Dec 02 2017 Richard W.M. Jones <rjones@redhat.com> - 0.7-2
- OCaml 4.06.0 rebuild.

* Mon Nov 20 2017 Andy Li <andy@onthewings.net> - 0.7-1
- Initial RPM release.
